#include "queue.h"

Queue::Queue ()
{
	size = (unsigned int) 0;
	head = (QNODE_PTR) NULL;
	tail = (QNODE_PTR) NULL;
}

Queue::~Queue () {}

unsigned int		Queue::get_size() const		{ return size; }

int					Queue::enqueue (int * numbers)
{
	QNODE_PTR		temp = new QNODE;	// Assume it always succeeds.
	
	temp->rndnums = numbers;
	temp->next = (QNODE_PTR) NULL;
	if (size == 0)
		head = temp;
	else
		tail->next = temp;
	tail = temp;
	size++;

	return 1;	// Always succeeds. Assume not > 2^32 - 1 elements. :-)
}

int *			Queue::dequeue ()
{
	QNODE_PTR	temp;
	int *		numbers = (int *) NULL;

	if (size == 0) {
		std::cerr << "~~~~~~~~~~ QUEUE ERROR: NULL pointer will be returned! " << std::endl;
		return	numbers;	// NULL pointer to indicate error.
	}

	size--;
	numbers = head->rndnums;
	temp = head;
	head = head->next;
	delete temp;

	return numbers;
}
