/*
** Implementation of a queue that stores chunks with random numbers
** which will be used by "solver" threads.
*/

#ifndef __QUEUE_H__
#define __QUEUE_H__

#include <iostream>

struct qnode {
	int *			rndnums;	// Store directly results from rand ()
	struct qnode *	next;
};

typedef struct qnode QNODE;
typedef QNODE * QNODE_PTR;

class Queue {
	public:
						Queue ();
						~Queue ();
		unsigned int	get_size () const;
		int				enqueue (int *);
		int *			dequeue ();

	private:
		QNODE_PTR		head;
		QNODE_PTR		tail;
		unsigned int	size;
		
};

typedef Queue QUEUE;
typedef QUEUE * QUEUE_PTR;

#endif
